﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;

namespace PlatformSDKSample
{
    using EPTZCommand = PlatformSDK.EPTZCommand;
    using EPTZType = PlatformSDK.EPTZType;

    public class PTZPanel : Form
    {
        private Button buttonPtzUp;
        private Button buttonPtzHome;
        private Button buttonPtzLeft;
        private Button buttonPtzRight;
        private Button buttonPtzZoomIn;
        private Button buttonPtzDown;
        private Button buttonPtzLeftUp;
        private Button buttonPtzRightUp;
        private Button buttonPtzRightDown;
        private Button buttonPtzLeftDown;
        private Label label1;
        private Label label2;
        private ComboBox comboBoxPtzType;
        private ComboBox comboBoxPtzModel;
        private Button buttonPtzZoomOut;
        private Button buttonPanStart;
        private Button buttonPanStop;
        private Label label3;
        private Label label4;
        private Button buttonFocusNear;
        private Button buttonFocusFar;
        private Button buttonFocusAuto;
        private Button buttonSetHome;
        private Button buttonDefaultHome;
        private Label label5;
        private Button buttonIrisAuto;
        private Button buttonIrisStop;
        private Button buttonIrisOpen;
        private Button buttonPatrol;
        private TextBox textBoxX;
        private Label label6;
        private Label label7;
        private TextBox textBoxY;
        private Label label8;
        private TextBox textBoxSpeed;
        private Button buttonContinuousPTZ;
        private Button buttonStopPTZ;
        private Label label9;
        private TextBox inputPresetName;
        private Button movePresetButton;
        private Button getPresetButton;
        private MainUI mainUI;

        public PTZPanel(MainUI pMainUI)
        {
            InitializeComponent();

            mainUI = pMainUI;
        }

        private void InitializeComponent()
        {
            this.buttonPtzUp = new System.Windows.Forms.Button();
            this.buttonPtzHome = new System.Windows.Forms.Button();
            this.buttonPtzLeft = new System.Windows.Forms.Button();
            this.buttonPtzRight = new System.Windows.Forms.Button();
            this.buttonPtzZoomIn = new System.Windows.Forms.Button();
            this.buttonPtzZoomOut = new System.Windows.Forms.Button();
            this.buttonPtzDown = new System.Windows.Forms.Button();
            this.buttonPtzLeftUp = new System.Windows.Forms.Button();
            this.buttonPtzRightUp = new System.Windows.Forms.Button();
            this.buttonPtzRightDown = new System.Windows.Forms.Button();
            this.buttonPtzLeftDown = new System.Windows.Forms.Button();
            this.label1 = new System.Windows.Forms.Label();
            this.label2 = new System.Windows.Forms.Label();
            this.comboBoxPtzType = new System.Windows.Forms.ComboBox();
            this.comboBoxPtzModel = new System.Windows.Forms.ComboBox();
            this.buttonPanStart = new System.Windows.Forms.Button();
            this.buttonPanStop = new System.Windows.Forms.Button();
            this.label3 = new System.Windows.Forms.Label();
            this.label4 = new System.Windows.Forms.Label();
            this.buttonFocusNear = new System.Windows.Forms.Button();
            this.buttonFocusFar = new System.Windows.Forms.Button();
            this.buttonFocusAuto = new System.Windows.Forms.Button();
            this.buttonSetHome = new System.Windows.Forms.Button();
            this.buttonDefaultHome = new System.Windows.Forms.Button();
            this.label5 = new System.Windows.Forms.Label();
            this.buttonIrisAuto = new System.Windows.Forms.Button();
            this.buttonIrisStop = new System.Windows.Forms.Button();
            this.buttonIrisOpen = new System.Windows.Forms.Button();
            this.buttonPatrol = new System.Windows.Forms.Button();
            this.textBoxX = new System.Windows.Forms.TextBox();
            this.label6 = new System.Windows.Forms.Label();
            this.label7 = new System.Windows.Forms.Label();
            this.textBoxY = new System.Windows.Forms.TextBox();
            this.label8 = new System.Windows.Forms.Label();
            this.textBoxSpeed = new System.Windows.Forms.TextBox();
            this.buttonContinuousPTZ = new System.Windows.Forms.Button();
            this.buttonStopPTZ = new System.Windows.Forms.Button();
            this.label9 = new System.Windows.Forms.Label();
            this.inputPresetName = new System.Windows.Forms.TextBox();
            this.movePresetButton = new System.Windows.Forms.Button();
            this.getPresetButton = new System.Windows.Forms.Button();
            this.SuspendLayout();
            // 
            // buttonPtzUp
            // 
            this.buttonPtzUp.Location = new System.Drawing.Point(58, 17);
            this.buttonPtzUp.Name = "buttonPtzUp";
            this.buttonPtzUp.Size = new System.Drawing.Size(39, 39);
            this.buttonPtzUp.TabIndex = 0;
            this.buttonPtzUp.Text = "↑";
            this.buttonPtzUp.UseVisualStyleBackColor = true;
            this.buttonPtzUp.Click += new System.EventHandler(this.buttonPtzUp_Click);
            // 
            // buttonPtzHome
            // 
            this.buttonPtzHome.Location = new System.Drawing.Point(58, 62);
            this.buttonPtzHome.Name = "buttonPtzHome";
            this.buttonPtzHome.Size = new System.Drawing.Size(39, 39);
            this.buttonPtzHome.TabIndex = 1;
            this.buttonPtzHome.Text = "Ⓗ";
            this.buttonPtzHome.UseVisualStyleBackColor = true;
            this.buttonPtzHome.Click += new System.EventHandler(this.buttonPtzHome_Click);
            // 
            // buttonPtzLeft
            // 
            this.buttonPtzLeft.Location = new System.Drawing.Point(13, 62);
            this.buttonPtzLeft.Name = "buttonPtzLeft";
            this.buttonPtzLeft.Size = new System.Drawing.Size(39, 39);
            this.buttonPtzLeft.TabIndex = 2;
            this.buttonPtzLeft.Text = "←";
            this.buttonPtzLeft.UseVisualStyleBackColor = true;
            this.buttonPtzLeft.Click += new System.EventHandler(this.buttonPtzLeft_Click);
            // 
            // buttonPtzRight
            // 
            this.buttonPtzRight.Location = new System.Drawing.Point(103, 62);
            this.buttonPtzRight.Name = "buttonPtzRight";
            this.buttonPtzRight.Size = new System.Drawing.Size(39, 39);
            this.buttonPtzRight.TabIndex = 3;
            this.buttonPtzRight.Text = "→";
            this.buttonPtzRight.UseVisualStyleBackColor = true;
            this.buttonPtzRight.Click += new System.EventHandler(this.buttonPtzRight_Click);
            // 
            // buttonPtzZoomIn
            // 
            this.buttonPtzZoomIn.Location = new System.Drawing.Point(52, 164);
            this.buttonPtzZoomIn.Name = "buttonPtzZoomIn";
            this.buttonPtzZoomIn.Size = new System.Drawing.Size(30, 34);
            this.buttonPtzZoomIn.TabIndex = 4;
            this.buttonPtzZoomIn.Text = "+";
            this.buttonPtzZoomIn.UseVisualStyleBackColor = true;
            this.buttonPtzZoomIn.Click += new System.EventHandler(this.buttonPtzZoomIn_Click);
            // 
            // buttonPtzZoomOut
            // 
            this.buttonPtzZoomOut.Location = new System.Drawing.Point(13, 164);
            this.buttonPtzZoomOut.Name = "buttonPtzZoomOut";
            this.buttonPtzZoomOut.Size = new System.Drawing.Size(29, 34);
            this.buttonPtzZoomOut.TabIndex = 5;
            this.buttonPtzZoomOut.Text = "-";
            this.buttonPtzZoomOut.UseVisualStyleBackColor = true;
            this.buttonPtzZoomOut.Click += new System.EventHandler(this.buttonPtzZoomOut_Click);
            // 
            // buttonPtzDown
            // 
            this.buttonPtzDown.Location = new System.Drawing.Point(58, 107);
            this.buttonPtzDown.Name = "buttonPtzDown";
            this.buttonPtzDown.Size = new System.Drawing.Size(39, 39);
            this.buttonPtzDown.TabIndex = 6;
            this.buttonPtzDown.Text = "↓";
            this.buttonPtzDown.UseVisualStyleBackColor = true;
            this.buttonPtzDown.Click += new System.EventHandler(this.buttonPtzDown_Click);
            // 
            // buttonPtzLeftUp
            // 
            this.buttonPtzLeftUp.Location = new System.Drawing.Point(13, 17);
            this.buttonPtzLeftUp.Name = "buttonPtzLeftUp";
            this.buttonPtzLeftUp.Size = new System.Drawing.Size(39, 39);
            this.buttonPtzLeftUp.TabIndex = 7;
            this.buttonPtzLeftUp.Text = "↖";
            this.buttonPtzLeftUp.UseVisualStyleBackColor = true;
            this.buttonPtzLeftUp.Click += new System.EventHandler(this.buttonPtzLeftUp_Click);
            // 
            // buttonPtzRightUp
            // 
            this.buttonPtzRightUp.Location = new System.Drawing.Point(103, 17);
            this.buttonPtzRightUp.Name = "buttonPtzRightUp";
            this.buttonPtzRightUp.Size = new System.Drawing.Size(39, 39);
            this.buttonPtzRightUp.TabIndex = 8;
            this.buttonPtzRightUp.Text = "↗";
            this.buttonPtzRightUp.UseVisualStyleBackColor = true;
            this.buttonPtzRightUp.Click += new System.EventHandler(this.buttonPtzRightUp_Click);
            // 
            // buttonPtzRightDown
            // 
            this.buttonPtzRightDown.Location = new System.Drawing.Point(103, 107);
            this.buttonPtzRightDown.Name = "buttonPtzRightDown";
            this.buttonPtzRightDown.Size = new System.Drawing.Size(39, 39);
            this.buttonPtzRightDown.TabIndex = 9;
            this.buttonPtzRightDown.Text = "↘";
            this.buttonPtzRightDown.UseVisualStyleBackColor = true;
            this.buttonPtzRightDown.Click += new System.EventHandler(this.buttonPtzRightDown_Click);
            // 
            // buttonPtzLeftDown
            // 
            this.buttonPtzLeftDown.Location = new System.Drawing.Point(13, 107);
            this.buttonPtzLeftDown.Name = "buttonPtzLeftDown";
            this.buttonPtzLeftDown.Size = new System.Drawing.Size(39, 39);
            this.buttonPtzLeftDown.TabIndex = 10;
            this.buttonPtzLeftDown.Text = "↙";
            this.buttonPtzLeftDown.UseVisualStyleBackColor = true;
            this.buttonPtzLeftDown.Click += new System.EventHandler(this.buttonPtzLeftDown_Click);
            // 
            // label1
            // 
            this.label1.AutoSize = true;
            this.label1.Location = new System.Drawing.Point(159, 26);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(29, 12);
            this.label1.TabIndex = 11;
            this.label1.Text = "Type";
            // 
            // label2
            // 
            this.label2.AutoSize = true;
            this.label2.Location = new System.Drawing.Point(159, 62);
            this.label2.Name = "label2";
            this.label2.Size = new System.Drawing.Size(35, 12);
            this.label2.TabIndex = 12;
            this.label2.Text = "Model";
            // 
            // comboBoxPtzType
            // 
            this.comboBoxPtzType.FormattingEnabled = true;
            this.comboBoxPtzType.Items.AddRange(new object[] {
            "Physical PTZ",
            "ePTZ"});
            this.comboBoxPtzType.Location = new System.Drawing.Point(210, 23);
            this.comboBoxPtzType.Name = "comboBoxPtzType";
            this.comboBoxPtzType.Size = new System.Drawing.Size(137, 20);
            this.comboBoxPtzType.TabIndex = 13;
            this.comboBoxPtzType.SelectedIndex = 0;
            // 
            // comboBoxPtzModel
            // 
            this.comboBoxPtzModel.FormattingEnabled = true;
            this.comboBoxPtzModel.Items.AddRange(new object[] {
            "PZ7131",
            "PZ61x2",
            "SD7151"});
            this.comboBoxPtzModel.Location = new System.Drawing.Point(209, 59);
            this.comboBoxPtzModel.Name = "comboBoxPtzModel";
            this.comboBoxPtzModel.Size = new System.Drawing.Size(138, 20);
            this.comboBoxPtzModel.TabIndex = 14;
            // 
            // buttonPanStart
            // 
            this.buttonPanStart.Location = new System.Drawing.Point(198, 112);
            this.buttonPanStart.Name = "buttonPanStart";
            this.buttonPanStart.Size = new System.Drawing.Size(73, 34);
            this.buttonPanStart.TabIndex = 15;
            this.buttonPanStart.Text = "Start";
            this.buttonPanStart.UseVisualStyleBackColor = true;
            this.buttonPanStart.Click += new System.EventHandler(this.buttonPanStart_Click);
            // 
            // buttonPanStop
            // 
            this.buttonPanStop.Location = new System.Drawing.Point(277, 112);
            this.buttonPanStop.Name = "buttonPanStop";
            this.buttonPanStop.Size = new System.Drawing.Size(70, 34);
            this.buttonPanStop.TabIndex = 16;
            this.buttonPanStop.Text = "Stop";
            this.buttonPanStop.UseVisualStyleBackColor = true;
            this.buttonPanStop.Click += new System.EventHandler(this.buttonPanStop_Click);
            // 
            // label3
            // 
            this.label3.AutoSize = true;
            this.label3.Location = new System.Drawing.Point(159, 123);
            this.label3.Name = "label3";
            this.label3.Size = new System.Drawing.Size(22, 12);
            this.label3.TabIndex = 17;
            this.label3.Text = "Pan";
            // 
            // label4
            // 
            this.label4.AutoSize = true;
            this.label4.Location = new System.Drawing.Point(159, 177);
            this.label4.Name = "label4";
            this.label4.Size = new System.Drawing.Size(32, 12);
            this.label4.TabIndex = 18;
            this.label4.Text = "Focus";
            // 
            // buttonFocusNear
            // 
            this.buttonFocusNear.Location = new System.Drawing.Point(197, 164);
            this.buttonFocusNear.Name = "buttonFocusNear";
            this.buttonFocusNear.Size = new System.Drawing.Size(45, 34);
            this.buttonFocusNear.TabIndex = 19;
            this.buttonFocusNear.Text = "Near";
            this.buttonFocusNear.UseVisualStyleBackColor = true;
            this.buttonFocusNear.Click += new System.EventHandler(this.buttonFocusNear_Click);
            // 
            // buttonFocusFar
            // 
            this.buttonFocusFar.Location = new System.Drawing.Point(248, 164);
            this.buttonFocusFar.Name = "buttonFocusFar";
            this.buttonFocusFar.Size = new System.Drawing.Size(47, 34);
            this.buttonFocusFar.TabIndex = 20;
            this.buttonFocusFar.Text = "Far";
            this.buttonFocusFar.UseVisualStyleBackColor = true;
            this.buttonFocusFar.Click += new System.EventHandler(this.buttonFocusFar_Click);
            // 
            // buttonFocusAuto
            // 
            this.buttonFocusAuto.Location = new System.Drawing.Point(301, 164);
            this.buttonFocusAuto.Name = "buttonFocusAuto";
            this.buttonFocusAuto.Size = new System.Drawing.Size(45, 34);
            this.buttonFocusAuto.TabIndex = 21;
            this.buttonFocusAuto.Text = "Auto";
            this.buttonFocusAuto.UseVisualStyleBackColor = true;
            this.buttonFocusAuto.Click += new System.EventHandler(this.buttonFocusAuto_Click);
            // 
            // buttonSetHome
            // 
            this.buttonSetHome.Location = new System.Drawing.Point(13, 214);
            this.buttonSetHome.Name = "buttonSetHome";
            this.buttonSetHome.Size = new System.Drawing.Size(59, 34);
            this.buttonSetHome.TabIndex = 22;
            this.buttonSetHome.Text = "Set Home";
            this.buttonSetHome.UseVisualStyleBackColor = true;
            this.buttonSetHome.Click += new System.EventHandler(this.buttonSetHome_Click);
            // 
            // buttonDefaultHome
            // 
            this.buttonDefaultHome.Location = new System.Drawing.Point(78, 214);
            this.buttonDefaultHome.Name = "buttonDefaultHome";
            this.buttonDefaultHome.Size = new System.Drawing.Size(64, 34);
            this.buttonDefaultHome.TabIndex = 23;
            this.buttonDefaultHome.Text = "Default Home";
            this.buttonDefaultHome.UseVisualStyleBackColor = true;
            this.buttonDefaultHome.Click += new System.EventHandler(this.buttonDefaultHome_Click);
            // 
            // label5
            // 
            this.label5.AutoSize = true;
            this.label5.Location = new System.Drawing.Point(159, 225);
            this.label5.Name = "label5";
            this.label5.Size = new System.Drawing.Size(20, 12);
            this.label5.TabIndex = 24;
            this.label5.Text = "Iris";
            // 
            // buttonIrisAuto
            // 
            this.buttonIrisAuto.Location = new System.Drawing.Point(301, 214);
            this.buttonIrisAuto.Name = "buttonIrisAuto";
            this.buttonIrisAuto.Size = new System.Drawing.Size(45, 34);
            this.buttonIrisAuto.TabIndex = 27;
            this.buttonIrisAuto.Text = "Auto";
            this.buttonIrisAuto.UseVisualStyleBackColor = true;
            this.buttonIrisAuto.Click += new System.EventHandler(this.buttonIrisAuto_Click);
            // 
            // buttonIrisStop
            // 
            this.buttonIrisStop.Location = new System.Drawing.Point(248, 214);
            this.buttonIrisStop.Name = "buttonIrisStop";
            this.buttonIrisStop.Size = new System.Drawing.Size(47, 34);
            this.buttonIrisStop.TabIndex = 26;
            this.buttonIrisStop.Text = "Stop";
            this.buttonIrisStop.UseVisualStyleBackColor = true;
            this.buttonIrisStop.Click += new System.EventHandler(this.buttonIrisStop_Click);
            // 
            // buttonIrisOpen
            // 
            this.buttonIrisOpen.Location = new System.Drawing.Point(197, 214);
            this.buttonIrisOpen.Name = "buttonIrisOpen";
            this.buttonIrisOpen.Size = new System.Drawing.Size(45, 34);
            this.buttonIrisOpen.TabIndex = 25;
            this.buttonIrisOpen.Text = "Open";
            this.buttonIrisOpen.UseVisualStyleBackColor = true;
            this.buttonIrisOpen.Click += new System.EventHandler(this.buttonIrisOpen_Click);
            // 
            // buttonPatrol
            // 
            this.buttonPatrol.Location = new System.Drawing.Point(92, 164);
            this.buttonPatrol.Name = "buttonPatrol";
            this.buttonPatrol.Size = new System.Drawing.Size(50, 34);
            this.buttonPatrol.TabIndex = 28;
            this.buttonPatrol.Text = "Patrol";
            this.buttonPatrol.UseVisualStyleBackColor = true;
            this.buttonPatrol.Click += new System.EventHandler(this.buttonPatrol_Click);
            // 
            // textBoxX
            // 
            this.textBoxX.Location = new System.Drawing.Point(32, 271);
            this.textBoxX.Name = "textBoxX";
            this.textBoxX.Size = new System.Drawing.Size(110, 22);
            this.textBoxX.TabIndex = 29;
            this.textBoxX.Text = "0";
            // 
            // label6
            // 
            this.label6.AutoSize = true;
            this.label6.Location = new System.Drawing.Point(13, 274);
            this.label6.Name = "label6";
            this.label6.Size = new System.Drawing.Size(13, 12);
            this.label6.TabIndex = 30;
            this.label6.Text = "X";
            // 
            // label7
            // 
            this.label7.AutoSize = true;
            this.label7.Location = new System.Drawing.Point(13, 312);
            this.label7.Name = "label7";
            this.label7.Size = new System.Drawing.Size(13, 12);
            this.label7.TabIndex = 32;
            this.label7.Text = "Y";
            // 
            // textBoxY
            // 
            this.textBoxY.Location = new System.Drawing.Point(32, 309);
            this.textBoxY.Name = "textBoxY";
            this.textBoxY.Size = new System.Drawing.Size(110, 22);
            this.textBoxY.TabIndex = 31;
            this.textBoxY.Text = "0";
            // 
            // label8
            // 
            this.label8.AutoSize = true;
            this.label8.Location = new System.Drawing.Point(159, 274);
            this.label8.Name = "label8";
            this.label8.Size = new System.Drawing.Size(33, 12);
            this.label8.TabIndex = 34;
            this.label8.Text = "Speed";
            // 
            // textBoxSpeed
            // 
            this.textBoxSpeed.Location = new System.Drawing.Point(197, 271);
            this.textBoxSpeed.Name = "textBoxSpeed";
            this.textBoxSpeed.Size = new System.Drawing.Size(110, 22);
            this.textBoxSpeed.TabIndex = 33;
            this.textBoxSpeed.Text = "1";
            // 
            // buttonContinuousPTZ
            // 
            this.buttonContinuousPTZ.Location = new System.Drawing.Point(197, 301);
            this.buttonContinuousPTZ.Name = "buttonContinuousPTZ";
            this.buttonContinuousPTZ.Size = new System.Drawing.Size(74, 34);
            this.buttonContinuousPTZ.TabIndex = 35;
            this.buttonContinuousPTZ.Text = "Continuous PTZ";
            this.buttonContinuousPTZ.UseVisualStyleBackColor = true;
            this.buttonContinuousPTZ.Click += new System.EventHandler(this.buttonContinuousPTZ_Click);
            // 
            // buttonStopPTZ
            // 
            this.buttonStopPTZ.Location = new System.Drawing.Point(277, 301);
            this.buttonStopPTZ.Name = "buttonStopPTZ";
            this.buttonStopPTZ.Size = new System.Drawing.Size(69, 34);
            this.buttonStopPTZ.TabIndex = 36;
            this.buttonStopPTZ.Text = "Stop PTZ";
            this.buttonStopPTZ.UseVisualStyleBackColor = true;
            this.buttonStopPTZ.Click += new System.EventHandler(this.buttonStopPTZ_Click);

            //
            // label9
            // 
            this.label9.AutoSize = true;
            this.label9.Location = new System.Drawing.Point(370, 26);
            this.label9.Name = "label9";
            this.label9.Size = new System.Drawing.Size(59, 12);
            this.label9.TabIndex = 29;
            this.label9.Text = "PresetName";
            // 
            // inputPresetName
            // 
            this.inputPresetName.Location = new System.Drawing.Point(435, 21);
            this.inputPresetName.Name = "inputPresetName";
            this.inputPresetName.Size = new System.Drawing.Size(100, 22);
            this.inputPresetName.TabIndex = 30;
            // 
            // movePresetButton
            // 
            this.movePresetButton.Location = new System.Drawing.Point(372, 50);
            this.movePresetButton.Name = "movePresetButton";
            this.movePresetButton.Size = new System.Drawing.Size(112, 23);
            this.movePresetButton.TabIndex = 31;
            this.movePresetButton.Text = "MoveToPreset";
            this.movePresetButton.UseVisualStyleBackColor = true;
            this.movePresetButton.Click += new System.EventHandler(this.MoveToPreset);
            // 
            // button1
            // 
            this.getPresetButton.Location = new System.Drawing.Point(372, 79);
            this.getPresetButton.Name = "button1";
            this.getPresetButton.Size = new System.Drawing.Size(112, 23);
            this.getPresetButton.TabIndex = 32;
            this.getPresetButton.Text = "GetPresetList";
            this.getPresetButton.UseVisualStyleBackColor = true;
            this.getPresetButton.Click += new System.EventHandler(this.GetPresetList);
            // 
            // PTZPanel
            // 
            this.ClientSize = new System.Drawing.Size(547, 347);
            this.Controls.Add(this.getPresetButton);
            this.Controls.Add(this.movePresetButton);
            this.Controls.Add(this.inputPresetName);
            this.Controls.Add(this.label9);
            this.Controls.Add(this.buttonStopPTZ);
            this.Controls.Add(this.buttonContinuousPTZ);
            this.Controls.Add(this.label8);
            this.Controls.Add(this.textBoxSpeed);
            this.Controls.Add(this.label7);
            this.Controls.Add(this.textBoxY);
            this.Controls.Add(this.label6);
            this.Controls.Add(this.textBoxX);
            this.Controls.Add(this.buttonPatrol);
            this.Controls.Add(this.buttonIrisAuto);
            this.Controls.Add(this.buttonIrisStop);
            this.Controls.Add(this.buttonIrisOpen);
            this.Controls.Add(this.label5);
            this.Controls.Add(this.buttonDefaultHome);
            this.Controls.Add(this.buttonSetHome);
            this.Controls.Add(this.buttonFocusAuto);
            this.Controls.Add(this.buttonFocusFar);
            this.Controls.Add(this.buttonFocusNear);
            this.Controls.Add(this.label4);
            this.Controls.Add(this.label3);
            this.Controls.Add(this.buttonPanStop);
            this.Controls.Add(this.buttonPanStart);
            this.Controls.Add(this.comboBoxPtzModel);
            this.Controls.Add(this.comboBoxPtzType);
            this.Controls.Add(this.label2);
            this.Controls.Add(this.label1);
            this.Controls.Add(this.buttonPtzLeftDown);
            this.Controls.Add(this.buttonPtzRightDown);
            this.Controls.Add(this.buttonPtzRightUp);
            this.Controls.Add(this.buttonPtzLeftUp);
            this.Controls.Add(this.buttonPtzDown);
            this.Controls.Add(this.buttonPtzZoomOut);
            this.Controls.Add(this.buttonPtzZoomIn);
            this.Controls.Add(this.buttonPtzRight);
            this.Controls.Add(this.buttonPtzLeft);
            this.Controls.Add(this.buttonPtzHome);
            this.Controls.Add(this.buttonPtzUp);
            this.MaximizeBox = false;
            this.Name = "PTZPanel";
            this.Text = "PTZ";
            this.ResumeLayout(false);
            this.PerformLayout();
            this.FormClosing += PTZPanel_FormClosing;
        }

        private void PTZPanel_FormClosing(object sender, FormClosingEventArgs e)
        {
            this.Hide();
            e.Cancel = true; // this cancels the close event.
        }

        void PTZCtrl(EPTZCommand cmd)
        {
            if (comboBoxPtzType.SelectedIndex < 0) return;
            EPTZType type = (EPTZType)comboBoxPtzType.SelectedIndex;
            mainUI.PTZCtrl(cmd, type, comboBoxPtzModel.Text);
        }

        private void buttonPtzUp_Click(object sender, EventArgs e)
        {
            PTZCtrl(EPTZCommand.up);
        }

        private void buttonPtzRightUp_Click(object sender, EventArgs e)
        {
            PTZCtrl(EPTZCommand.rightUp);
        }

        private void buttonPtzRight_Click(object sender, EventArgs e)
        {
            PTZCtrl(EPTZCommand.right);
        }

        private void buttonPtzRightDown_Click(object sender, EventArgs e)
        {
            PTZCtrl(EPTZCommand.rightDown);
        }

        private void buttonPtzDown_Click(object sender, EventArgs e)
        {
            PTZCtrl(EPTZCommand.down);
        }

        private void buttonPtzLeftDown_Click(object sender, EventArgs e)
        {
            PTZCtrl(EPTZCommand.leftDown);
        }

        private void buttonPtzLeft_Click(object sender, EventArgs e)
        {
            PTZCtrl(EPTZCommand.left);
        }

        private void buttonPtzLeftUp_Click(object sender, EventArgs e)
        {
            PTZCtrl(EPTZCommand.leftUp);
        }

        private void buttonPtzHome_Click(object sender, EventArgs e)
        {
            PTZCtrl(EPTZCommand.home);
        }

        private void buttonPtzZoomOut_Click(object sender, EventArgs e)
        {
            PTZCtrl(EPTZCommand.zoomOut);
        }

        private void buttonPtzZoomIn_Click(object sender, EventArgs e)
        {
            PTZCtrl(EPTZCommand.zoomIn);
        }

        private void buttonPanStart_Click(object sender, EventArgs e)
        {
            PTZCtrl(EPTZCommand.startPan);
        }

        private void buttonPanStop_Click(object sender, EventArgs e)
        {
            PTZCtrl(EPTZCommand.stopPan);
        }

        private void buttonFocusNear_Click(object sender, EventArgs e)
        {
            PTZCtrl(EPTZCommand.focusNear);
        }

        private void buttonFocusFar_Click(object sender, EventArgs e)
        {
            PTZCtrl(EPTZCommand.focusFar);
        }

        private void buttonFocusAuto_Click(object sender, EventArgs e)
        {
            PTZCtrl(EPTZCommand.focusAuto);
        }

        private void buttonIrisOpen_Click(object sender, EventArgs e)
        {
            PTZCtrl(EPTZCommand.irisOpen);
        }

        private void buttonIrisStop_Click(object sender, EventArgs e)
        {
            PTZCtrl(EPTZCommand.irisClose);
        }

        private void buttonIrisAuto_Click(object sender, EventArgs e)
        {
            PTZCtrl(EPTZCommand.irisAuto);
        }

        private void buttonSetHome_Click(object sender, EventArgs e)
        {
            PTZCtrl(EPTZCommand.setHome);
        }

        private void buttonDefaultHome_Click(object sender, EventArgs e)
        {
            PTZCtrl(EPTZCommand.defaultHome);
        }

        private void buttonPatrol_Click(object sender, EventArgs e)
        {
            PTZCtrl(EPTZCommand.startPatrol);
        }

        private void buttonContinuousPTZ_Click(object sender, EventArgs e)
        {
            mainUI.ContinuousPTZCtrl(int.Parse(textBoxSpeed.Text), int.Parse(textBoxX.Text), int.Parse(textBoxY.Text));
        }

        private void buttonStopPTZ_Click(object sender, EventArgs e)
        {
            mainUI.StopPTZCtrl();
        }
   
        private void MoveToPreset(object sender, EventArgs e)
        {
            mainUI.PTZMoveToPreset(this.inputPresetName.Text);
        }

        private void GetPresetList(object sender, EventArgs e)
        {
            mainUI.GetPTZPresetList();
        }
    }
}
