﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Runtime.InteropServices;

using PlatformSDKSample;

namespace QueryNVRLog
{
    public partial class Form1 : Form
    {
        public IntPtr loginID;
        public Form1()
        {
            InitializeComponent();
            List<KeyValuePair<string, PlatformSDK.ENVRLogType>> logTypeList = new List<KeyValuePair<string, PlatformSDK.ENVRLogType>>
            {
                new KeyValuePair<string, PlatformSDK.ENVRLogType>("System", PlatformSDK.ENVRLogType.system),
                new KeyValuePair<string, PlatformSDK.ENVRLogType>("Recording",PlatformSDK.ENVRLogType.recording),
                new KeyValuePair<string, PlatformSDK.ENVRLogType>("User", PlatformSDK.ENVRLogType.user),
                new KeyValuePair<string, PlatformSDK.ENVRLogType>("Error", PlatformSDK.ENVRLogType.error),
                new KeyValuePair<string, PlatformSDK.ENVRLogType>("AbnormalEvent", PlatformSDK.ENVRLogType.abnormalEvent)
            };

            logType.DataSource = logTypeList;
            logType.DisplayMember = "Key";
            logType.ValueMember = "Value";
        }

        private unsafe void query_Click(object sender, EventArgs e)
        {
            var request = new PlatformSDK.TQueryNVRLogRequest();

            request.maxRecords = uint.Parse(maxRecord.Text);
            request.startTime = uint.Parse(startTime.Text);
            request.endTime = uint.Parse(endTime.Text);
            request.logType = (PlatformSDK.ENVRLogType)logType.SelectedValue;

            int logNVRRecordNum = 0;
            IntPtr pLogNVRRecords = IntPtr.Zero;

            int ret = PlatformSDK.QueryNVRLogList(loginID, ref request, ref pLogNVRRecords, &logNVRRecordNum);

            var allXmlString = "";

            for (int i = 0; i < logNVRRecordNum; ++i)
            {
                IntPtr pLogInfo = new IntPtr(pLogNVRRecords.ToInt64() + Marshal.SizeOf(typeof(PlatformSDK.TQueryNVRLogResponse)) * i);
                PlatformSDK.TQueryNVRLogResponse logNVRInfo = (PlatformSDK.TQueryNVRLogResponse)Marshal.PtrToStructure(pLogInfo, typeof(PlatformSDK.TQueryNVRLogResponse));
                var xmlString = Marshal.PtrToStringAnsi(logNVRInfo.content);
                EventLog.Write("PlatformSDK.QueryNVRLogList, Content = {0}", xmlString);

                allXmlString += xmlString;
            }

            ResultBlock.Text = allXmlString;
        }
    }
}
